/// <reference types="rx-core" />
/// <reference types="rx-core-binding" />
/// <reference types="rx-lite" />
/// <reference types="rx-lite-aggregates" />
/// <reference types="rx-lite-backpressure" />
/// <reference types="rx-lite-coincidence" />
/// <reference types="rx-lite-experimental" />
/// <reference types="rx-lite-joinpatterns" />
/// <reference types="rx-lite-time" />
import { Emitter } from 'typed-rx-emitter';
export declare type Undux<Actions extends object> = {
    [K in keyof Actions]: {
        key: K;
        previousValue: Actions[K];
        value: Actions[K];
    };
};
export declare class Store<Actions extends object> extends Emitter<Actions> {
    private state;
    private befores;
    private emitter;
    constructor(state: Actions);
    before<K extends keyof Actions>(key: K): Rx.Observable<Undux<Actions>[K]>;
    beforeAll<K extends keyof Actions>(): Rx.Observable<Undux<Actions>[keyof Actions]>;
    get<K extends keyof Actions>(key: K): Actions[K];
    set<K extends keyof Actions>(key: K): (value: Actions[K]) => Emitter<Actions>;
}
export declare function createStore<Actions extends object>(initialState: Actions): Store<Actions>;
export declare type Plugin = <Actions extends object>(store: Store<Actions>) => Store<Actions>;
export * from './plugins/logger';
export * from './react';
