"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var typed_rx_emitter_1 = require("typed-rx-emitter");
var Store = /** @class */ (function (_super) {
    __extends(Store, _super);
    function Store(state) {
        var _this = _super.call(this) || this;
        _this.state = state;
        _this.befores = new typed_rx_emitter_1.Emitter();
        _this.emitter = new typed_rx_emitter_1.Emitter();
        var _loop_1 = function (key) {
            this_1.emitter.on(key).subscribe(function (value) {
                var previousValue = state[key];
                _this.befores.emit(key, { key: key, previousValue: previousValue, value: value });
                state[key] = value;
                _this.emit(key, value);
            });
        };
        var this_1 = this;
        for (var key in state) {
            _loop_1(key);
        }
        return _this;
    }
    Store.prototype.before = function (key) {
        return this.befores.on(key);
    };
    Store.prototype.beforeAll = function () {
        return this.befores.all();
    };
    Store.prototype.get = function (key) {
        return this.state[key];
    };
    Store.prototype.set = function (key) {
        var _this = this;
        return function (value) {
            return _this.emitter.emit(key, value);
        };
    };
    return Store;
}(typed_rx_emitter_1.Emitter));
exports.Store = Store;
function createStore(initialState) {
    return new Store(initialState);
}
exports.createStore = createStore;
__export(require("./plugins/logger"));
__export(require("./react"));
//# sourceMappingURL=index.js.map