"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
function connect(store) {
    return function () {
        var listenOn = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            listenOn[_i] = arguments[_i];
        }
        return function (Component) {
            var state;
            var Class = /** @class */ (function (_super) {
                __extends(class_1, _super);
                function class_1() {
                    return _super !== null && _super.apply(this, arguments) || this;
                }
                class_1.prototype.componentDidMount = function () {
                    var _this = this;
                    state = listenOn.map(function (key) {
                        var ignore = false;
                        return [
                            store.before(key).subscribe(function (_a) {
                                var previousValue = _a.previousValue, value = _a.value;
                                if (equals(previousValue, value)) {
                                    return ignore = true;
                                }
                            }),
                            store.on(key).subscribe(function () {
                                if (ignore) {
                                    return ignore = false;
                                }
                                _this.forceUpdate();
                            })
                        ];
                    });
                };
                class_1.prototype.componentWillUnmount = function () {
                    state.forEach(function (_) { return _.forEach(function (_) { return _.dispose(); }); });
                };
                class_1.prototype.render = function () {
                    return React.createElement(Component, __assign({}, this.props, { store: store }));
                };
                return class_1;
            }(React.Component));
            Class.displayName = "withStore(" + getDisplayName(Component) + ")";
            return Class;
        };
    };
}
exports.connect = connect;
function getDisplayName(Component) {
    return Component.displayName || Component.name || 'Component';
}
/**
 * TODO: Avoid diffing by passing individual values into a React component
 * rather than the whole `store`, and letting React and `shouldComponentUpdate`
 * handle diffing for us.
 */
function equals(a, b) {
    return a === b;
}
//# sourceMappingURL=react.js.map